二分查找5️⃣-山脉数组的封顶索引

题目链接: 852. 山脉数组的峰顶索引

题目描述:

给定一个长度为 n 的整数 山脉 数组 arr ,其中的值递增到一个 峰值元素 然后递减。

返回峰值元素的下标。

你必须设计并实现时间复杂度为 O(log(n)) 的解决方案。

示例 1:

复制代码
输入:arr = [0,1,0]
输出:1

示例 2:

复制代码
输入:arr = [0,2,1,0]
输出:1

示例 3:

复制代码
输入:arr = [0,10,5,2]
输出:1

提示:

  • 3 <= arr.length <= 105

  • 0 <= arr[i] <= 106

  • 题目数据 保证 arr 是一个山脉数组

解法一(暴力查找):

算法思路:

◦ 峰顶的特点:比两侧的元素都要大。

◦ 因此,我们可以遍历数组内的每一个元素,找到某一个元素比两边的元素大即可。

cpp 复制代码
class Solution {
public:
    int peakIndexInMountainArray(vector<int>& arr) {
        for(int i = 1 ; i < arr.size()-1; i++){
            // 遍历数组内每一个元素,直到找到峰顶
            if(arr[i] > arr[i-1] && arr[i] > arr[i+1])
            return i;
        }

        // 为了处理oj需要控制所有路径都有返回值
        return -1;
    }
};

解法二(二分查找):

算法思路:

本题的数组不是有序数组,但我们依然可以使用二分查找,原因是因为我们发现了**"二段性"**,对于山峰来说,我们会发现封顶的值是最大,对于封顶左边来说,后一个数比前一个数大;对于封顶右边来说,后一个数比前一个数小,因此我们可以分以下三种情况:

◦ 如果 mid 位置呈现上升趋势,说明我们接下来要在 mid + 1, right 区间继续搜索;

◦ 如果 mid 位置呈现下降趋势,说明我们接下来要在 left, mid - 1 区间搜索;

◦ 如果 mid 位置就是山峰,直接返回结果。

cpp 复制代码
class Solution {
public:
    int peakIndexInMountainArray(vector<int>& arr) {
        int left = 0, right = arr.size()-1;
        while(left < right){
            int mid = left + (right - left) / 2;
            if(arr[mid] < arr[mid+1])
                left = mid + 1;
            else
                right = mid ;
        }
        return left;
    }
};
相关推荐
Navigator_Z3 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH3 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶4 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊4 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发6 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔8 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
青少儿编程课堂9 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan10 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
Dream it possible!1 天前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划